from vrml_analyse import *

class vrml_lights(vrml_analyse):

	def __init__(self,string,parent):
		self.VRMLReserved= ["ambientIntensity", "color", "direction", "intensity", "on", "position","attenuation","radius","location","beamWidth", "cutOffAngle"]
		self.keys = []
		self.string = string
		self.parent = parent


	def switchFunctions(self,string, parent):
		for key in self.keys:
			if key[0] == "ambientIntensity":
				self.ambientIntensity(string[key[1]:key[2]],parent)
			elif key[0] == "color":
				self.color(string[key[1]:key[2]],parent)
			elif key[0] == "direction":
				self.direction(string[key[1]:key[2]], parent)
			elif key[0] == "intensity":
				self.intensity(string[key[1]:key[2]], parent)
			elif key[0] == "on":
				self.on(string[key[1]:key[2]], parent)
			elif key[0] == "position":
				self.position(string[key[1]:key[2]], parent)
			elif key[0] == "attenuation":
				self.attenuation(string[key[1]:key[2]], parent)
			elif key[0] == "radius":
				self.radius(string[key[1]:key[2]], parent)
			elif key[0] == "location":
				self.location(string[key[1]:key[2]], parent)
			elif key[0] == "beamWidth":
				self.beamWidth(string[key[1]:key[2]], parent)
			elif key[0] == "cutOffAngle":
				self.cutOffAngle(string[key[1]:key[2]], parent)


	def ambientIntensity(self,string,parent):
		while 1:
			name = self.getName(string)
			if name == None:
				return
			if name == 'ambientIntensity':
				ambientIntensity = self.getValues(string,3)
				#self.la.setEnergy(float(ambientIntensity[0]))
				return
			string = self.deleteString(string, name)


	def color(self,string.parent):
		while 1:
			name = self.getName(string)
			if name == None:
				return
			if name == 'color':
				color = self.getValues(string,3)
				#self.la.setColor(float(color[0]),float(color[1]),float(color[2]))			#not yet available
				return
			string = self.deleteString(string, name)

	def radius(self,string.parent):
		while 1:
			name = self.getName(string)
			if name == None:
				return
			if name == 'radius':
				radius = self.getValues(string,3)
				self.la.setSpotSize(float(radius[0]))
				return
			string = self.deleteString(string, name)


	def location(self,string.parent):
		while 1:
			name = self.getName(string)
			if name == None:
				return
			if name == 'location':
				location = self.getValues(string,3)
				self.ob.setLocation(float(location[0]),float(location[1]),float(location[2]))
				return
			string = self.deleteString(string, name)

	def direction(self,string.parent):
		while 1:
			name = self.getName(string)
			if name == None:
				return
			if name == 'direction':
				direction = self.getValues(string,3)
				#the given value iss a vector, it needs to be recalculated to angles
				be = sqrt(float(direction[0])*float(direction[0])+float(direction[1])*float(direction[1])+float(direction[2]))*float(direction[2])))
				direction[0] = acos(float(direction[0])/be)
				direction[1] = acos(float(direction[1])/be)
				direction[2] = acos(float(direction[2])/be)
				self.ob.setEuler(direction[0],direction[1],direction[2])
				return
			string = self.deleteString(string, name)



	def attenuation(self,string.parent):
		while 1:
			name = self.getName(string)
			if name == None:
				return
			if name == 'attenuation':
				attenuation = self.getValues(string,3)
				#self.la.setAttenuation(float(attenuation[0]),float(attenuation[1]),float(attenuation[2]))		#don't know what this means
				return
			string = self.deleteString(string, name)

	def beamWidth(self,string.parent):
		while 1:
			name = self.getName(string)
			if name == None:
				return
			if name == 'beamWidth':
				beamWidth = self.getValues(string,1)
				self.la.setDist(float(beamWidth[0]))
				return
			string = self.deleteString(string, name)

	def intensity(self,string.parent):
		while 1:
			name = self.getName(string)
			if name == None:
				return
			if name == 'intensity':
				intensity = self.getValues(string,1)
				setEnergy(float(intensity[0]))
				return
			string = self.deleteString(string, name)

	def on(self,string.parent):
		while 1:
			name = self.getName(string)
			if name == None:
				return
			if name == 'on':
				string = self.deleteString(string, name)
				name = self.getName(string)
				if name == 'FALSE':
					pass	#activate Lamp
				elif name == 'TRUE':
					pass	#deactivate Lamp
				return
			string = self.deleteString(string, name)



	def makeBlenderName(self, name):
		'''Blender only takes names with a length of 21 characters
		but vrml and the blender python objects take longer name
		that will be different in blender.
		to avoid problems with truncated names this function shortens
		the name'''
		if len(name) < 16:
			return name
		name = name[:16]
		app = 0
		while 1:
			try:
				Lamp.Get(name+str(app))
				app += 1
			except:
				return name+str(app)
		return name




	def setLight(self):
		'''creates a new Blender Light and applies the given properties,'''
		print 'creating Light...'
		self.string = self.splittString(self.string)
		breaker = 0
		namestring = self.string[0]
		while 1:
			name = self.getName(namestring)
			if name == None:
				print 'no Light created!'
				return
			elif name == 'DEF':
				breaker = 1
			elif name == 'USE':
				breaker = -1
			elif breaker == -1:
				ob = Object.Get(getNewName(self.parent))
				la = Object.Get(getNewName(name))
				ob.makeParent(la)
				return
			elif name == 'SpotLight' :
				if breaker < 2:
					self.la = Lamp.New('Spot')
					setNewName(name,self.la.name)
					self.ob = Object.New('Lamp', self.la.name)
					ob.link(self.la)
					self.SpotLight(self.parent, self.string[1][1:-1])
				break
			elif name == 'DirectionalLight':
				if breaker < 2:
					self.la = Lamp.New('Sun')
					setNewName(name,self.la.name)
					self.ob = Object.New('Lamp', self.la.name)
					ob.link(self.la)
					self.DirectionalLight(self.parent, self.string[1][1:-1])
				break
			elif name == 'PointLight':
				if breaker < 2:
					self.la = Lamp.New('Lamp')
					setNewName(name,self.la.name)
					self.ob = Object.New('Lamp', self.la.name)
					ob.link(self.la)
					self.PointLight(self.parent, self.string[1][1:-1])
				break
			elif breaker == 1:
				self.la = Lamp.New(self.makeBlenderName(name))
				#ob = Object.New('Mesh')
				#self.me = ob.getData()
				#self.me.name = name
				#self.me.update()
				#self.me = ob.getData()
				setNewName(name,self.la.name)
				#self.me = NMesh.New(name)
				breaker = 2
			namestring = self.deleteString(namestring, name)

	def SpotLight(self.parent, string):
		#make presets
		self.start(string,self.la.name)


	def PointLight(self.parent, string):
		#make presets
		self.start(string,self.la.name)



	def DirectionalLight(self.parent, string):
		#make presets
		self.start(string,self.la.name)


